package eu.eudat.dao.entities.security;

import eu.eudat.dao.DatabaseAccess;
import eu.eudat.dao.databaselayer.service.DatabaseService;
import eu.eudat.entities.UserToken;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.UUID;

/**
 * Created by ikalyvas on 12/15/2017.
 */
@Component("userTokenDao")
public class UserTokenDaoImpl extends DatabaseAccess<UserToken> implements UserTokenDao {

    @Autowired
    public UserTokenDaoImpl(DatabaseService<UserToken> databaseService) {
        this.setDatabaseService(databaseService);
    }

    @Override
    public UserToken createOrUpdate(UserToken item) {
        return this.getDatabaseService().createOrUpdate(item,UserToken.class);
    }

    @Override
    public UserToken find(UUID id) {
        return this.getDatabaseService().getQueryable(UserToken.class).where((builder, root) -> builder.equal(root.get("token"),id)).getSingle();
    }

    @Override
    public void delete(UserToken userToken) {
        this.getDatabaseService().delete(userToken);
    }
}
